Attribute VB_Name = "Module2"
' Global variables for crosshair positions
Public ch_x As Long  ' x pos
Public ch_y As Long  ' y pos
Public ch_w As Long  ' width
Public ch_h As Long  ' height
Public ch_t As Long  ' thickness
Public ch_a As Long  ' angle (degrees * 10)
Public ch_c As Variant  ' color
Public ch_type As Long   ' crosshair type
Public ch_trans As Boolean  ' transparent or not
Public ch_pinned As Boolean ' pinned or not
Public Const pi = 3.141592654
Public Const anglediv = 900 ' angle divisor


' Procedure to display crosshairs on form2
Public Sub draw_crosshairs()
    
    Dim maxlength ' used for max line length
    Dim x1, x2, y1, y2 ' used for temp calcs
    maxlength = Sqr((Form2.ScaleWidth ^ 2) + (Form2.ScaleHeight ^ 2))
    
    If ch_trans = True Then Form2.BackColor = RGB(0, 100, 0) Else Form2.BackColor = RGB(200, 200, 200)
    Form2.Cls
    Form2.DrawWidth = ch_t
    Select Case ch_type
    Case 1
        Form2.Line (ch_x - (maxlength * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - (maxlength * Sin(ch_a * pi / anglediv))))-(ch_x + (maxlength * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + (maxlength * Sin(ch_a * pi / anglediv)))), ch_c
        Form2.Line (ch_x - (maxlength * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + (maxlength * Cos(ch_a * pi / anglediv))))-(ch_x + (maxlength * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - (maxlength * Cos(ch_a * pi / anglediv)))), ch_c
    Case 2
        Form2.Line (ch_x - (maxlength * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - (maxlength * Sin(ch_a * pi / anglediv))))-(ch_x - ((ch_w / 2) * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - ((ch_w / 2) * Sin(ch_a * pi / anglediv)))), ch_c
        Form2.Line (ch_x + ((ch_w / 2) * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + ((ch_w / 2) * Sin(ch_a * pi / anglediv))))-(ch_x + (maxlength * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + (maxlength * Sin(ch_a * pi / anglediv)))), ch_c
        Form2.Line (ch_x - (maxlength * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + (maxlength * Cos(ch_a * pi / anglediv))))-(ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)))), ch_c
        Form2.Line (ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv))))-(ch_x + (maxlength * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - (maxlength * Cos(ch_a * pi / anglediv)))), ch_c
    Case 3
        x1 = ch_x - ((ch_w / 2) * Cos(ch_a * pi / anglediv)) - (maxlength * Sin(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_w / 2) * Sin(ch_a * pi / anglediv)) + (maxlength * Cos(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_w / 2) * Cos(ch_a * pi / anglediv)) + (maxlength * Sin(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_w / 2) * Sin(ch_a * pi / anglediv)) - (maxlength * Cos(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_w / 2) * Cos(ch_a * pi / anglediv)) - (maxlength * Sin(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_w / 2) * Sin(ch_a * pi / anglediv)) + (maxlength * Cos(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_w / 2) * Cos(ch_a * pi / anglediv)) + (maxlength * Sin(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_w / 2) * Sin(ch_a * pi / anglediv)) - (maxlength * Cos(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - (maxlength * Cos(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - (maxlength * Sin(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + (maxlength * Cos(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + (maxlength * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - (maxlength * Cos(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - (maxlength * Sin(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + (maxlength * Cos(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + (maxlength * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
    Case 4
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv)) - (maxlength * Cos(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv)) - (maxlength * Sin(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv)) - (maxlength * Sin(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv)) + (maxlength * Cos(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv)) - (maxlength * Sin(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv)) + (maxlength * Cos(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv)) + (maxlength * Cos(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv)) + (maxlength * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv)) + (maxlength * Cos(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv)) + (maxlength * Sin(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv)) + (maxlength * Sin(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv)) - (maxlength * Cos(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv)) + (maxlength * Sin(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv)) - (maxlength * Cos(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv)) - (maxlength * Cos(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv)) - (maxlength * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
    Case 5
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
    Case 6
        Form2.Line (ch_x - (maxlength * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - (maxlength * Sin(ch_a * pi / anglediv))))-(ch_x + (maxlength * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + (maxlength * Sin(ch_a * pi / anglediv)))), ch_c
        Form2.Line (ch_x - (maxlength * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + (maxlength * Cos(ch_a * pi / anglediv))))-(ch_x + (maxlength * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - (maxlength * Cos(ch_a * pi / anglediv)))), ch_c
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) + ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) + ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
        x1 = ch_x + ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y1 = ch_y - ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        x2 = ch_x - ((ch_h / 2) * Sin(ch_a * pi / anglediv)) - ((ch_w / 2) * Cos(ch_a * pi / anglediv))
        y2 = ch_y + ((ch_h / 2) * Cos(ch_a * pi / anglediv)) - ((ch_w / 2) * Sin(ch_a * pi / anglediv))
        Form2.Line (x1, Form2.ScaleHeight - y1)-(x2, Form2.ScaleHeight - y2), ch_c
    Case 7
        Form2.Circle (ch_x, Form2.ScaleHeight - ch_y), ch_w / 2, ch_c
    Case 8
        Form2.Line (ch_x - (maxlength * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - (maxlength * Sin(ch_a * pi / anglediv))))-(ch_x + (maxlength * Cos(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + (maxlength * Sin(ch_a * pi / anglediv)))), ch_c
        Form2.Line (ch_x - (maxlength * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y + (maxlength * Cos(ch_a * pi / anglediv))))-(ch_x + (maxlength * Sin(ch_a * pi / anglediv)), Form2.ScaleHeight - (ch_y - (maxlength * Cos(ch_a * pi / anglediv)))), ch_c
        Form2.Circle (ch_x, Form2.ScaleHeight - ch_y), ch_w / 2, ch_c
    Case 9
    Case 0
        ' Don't show anything
    Case Else
    End Select
    
    ' Update labels
    Form2.Label6.Caption = Str$(ch_x)
    Form2.Label7.Caption = Str$(ch_y)
    Form2.Label8.Caption = Str$(ch_w)
    Form2.Label9.Caption = Str$(ch_h)
    Form2.Label10.Caption = Str$(ch_a / (anglediv / 180))
    
    ' Set label color
    Form2.Label1.ForeColor = ch_c
    Form2.Label2.ForeColor = ch_c
    Form2.Label3.ForeColor = ch_c
    Form2.Label4.ForeColor = ch_c
    Form2.Label5.ForeColor = ch_c
    Form2.Label6.ForeColor = ch_c
    Form2.Label7.ForeColor = ch_c
    Form2.Label8.ForeColor = ch_c
    Form2.Label9.ForeColor = ch_c
    Form2.Label10.ForeColor = ch_c
    
End Sub

' Reset crosshairs
Public Sub init_crosshairs()
    
    ' Initialise crosshair variables
    ch_x = Form2.ScaleWidth / 2
    ch_y = Form2.ScaleHeight / 2
    ch_w = Form2.ScaleWidth / 10
    ch_h = Form2.ScaleHeight / 10
    ch_t = 1
    ch_a = 0
    ch_c = vbBlack
    ch_type = 1
    ch_trans = False
    ch_pinned = False
    
End Sub
    
